import pygame
from OpenGL.GL import *

from data import get_path

class Texture (object):
	min_filter = GL_LINEAR
	mag_filter = GL_LINEAR

	def __init__(self):
		self.tex = glGenTextures(1)

	def free(self):
		glDeleteTextures(self.tex)
	
	def __del__(self):
		glDeleteTextures(self.tex)
	
	def select(self):
		glBindTexture(GL_TEXTURE_2D, self.tex)

	def set(self, surface):
		self.select()
		glTexParameter(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR)
		glTexParameter(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR)
		glTexImage2D(GL_TEXTURE_2D, 0, GL_RGBA, surface.get_width(), surface.get_height(),
				0, GL_RGBA, GL_UNSIGNED_BYTE, pygame.image.tostring(surface, "RGBA"))

	def load(self, name):
		texture = pygame.image.load(get_path(name))
		self.set(texture)

